<?php
namespace Ep\Woo\Plugin\Product;

use Ep\Woo\Entity\Product\Grouped;
use Ep\Woo\Entity\Product\Simple;
use Ep\Wp\Plugin\PluginInterface;

/**
 * Zamijenjuje WC_Product klase našim implementacijama.
 *
 * @package Ep\Woo\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-woocommerce
 */
class Entity implements PluginInterface
{
    /**
     * Dodaje akcije i filtere u WordPress.
     *
     * @return void
     */
    public function __invoke(): void
    {
        add_filter('woocommerce_product_class', [$this, 'wc_product_class'], 10, 2);
    }

    /**
     * @param string $productClass
     * @param string $productType
     *
     * @return string
     */
    public function wc_product_class(string $productClass, string $productType): string
    {
        switch ($productType) {
            case 'grouped':
                $productClass = Grouped::class;
                break;
            case 'simple':
            default:
                $productClass = Simple::class;
        }

        return $productClass;
    }
}